package com.tashow.cloud.product.service.impl;

import com.tashow.cloud.product.dto.SkuServiceMaterialDO;
import com.tashow.cloud.product.mapper.SkuServiceMaterialMapper;
import com.tashow.cloud.product.service.SkuServiceMaterialService;
import com.tashow.cloud.product.vo.skuservicematerial.SkuServiceMaterialPageReqVO;
import com.tashow.cloud.product.vo.skuservicematerial.SkuServiceMaterialSaveReqVO;
import com.tashow.cloud.productapi.enums.ErrorCodeConstants;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.tashow.cloud.common.pojo.PageResult;
import com.tashow.cloud.common.pojo.PageParam;
import com.tashow.cloud.common.util.object.BeanUtils;


import static com.tashow.cloud.common.exception.util.ServiceExceptionUtil.exception;

/**
 * 服务物料详情 Service 实现类
 *
 * @author 芋道源码
 */
@Service
@Validated
public class SkuServiceMaterialServiceImpl implements SkuServiceMaterialService {

    @Resource
    private SkuServiceMaterialMapper skuServiceMaterialMapper;

    @Override
    public Long createSkuServiceMaterial(SkuServiceMaterialSaveReqVO createReqVO) {
        // 插入
        SkuServiceMaterialDO skuServiceMaterial = BeanUtils.toBean(createReqVO, SkuServiceMaterialDO.class);
        skuServiceMaterialMapper.insert(skuServiceMaterial);
        // 返回
        return skuServiceMaterial.getId();
    }

    @Override
    public void updateSkuServiceMaterial(SkuServiceMaterialSaveReqVO updateReqVO) {
        // 校验存在
        validateSkuServiceMaterialExists(updateReqVO.getId());
        // 更新
        SkuServiceMaterialDO updateObj = BeanUtils.toBean(updateReqVO, SkuServiceMaterialDO.class);
        skuServiceMaterialMapper.updateById(updateObj);
    }

    @Override
    public void deleteSkuServiceMaterial(Long id) {
        // 校验存在
        validateSkuServiceMaterialExists(id);
        // 删除
        skuServiceMaterialMapper.deleteById(id);
    }

    private void validateSkuServiceMaterialExists(Long id) {
        if (skuServiceMaterialMapper.selectById(id) == null) {
            throw exception(ErrorCodeConstants.SKU_SERVICE_MATERIAL_NOT_EXISTS);
        }
    }

    @Override
    public SkuServiceMaterialDO getSkuServiceMaterial(Long id) {
        return skuServiceMaterialMapper.selectById(id);
    }

    @Override
    public PageResult<SkuServiceMaterialDO> getSkuServiceMaterialPage(SkuServiceMaterialPageReqVO pageReqVO) {
        return null;
    }

}